/*
**  Copyright (C) 1993-1996, OFFIS, Oldenburg University and CERIUM
**  
**  This software and supporting documentation were
**  developed by 
**  
**    Institut OFFIS
**    Bereich Kommunikationssysteme
**    Westerstr. 10-12
**    26121 Oldenburg, Germany
**    
**    Fachbereich Informatik
**    Abteilung Prozessinformatik
**    Carl von Ossietzky Universitaet Oldenburg 
**    Ammerlaender Heerstr. 114-118
**    26111 Oldenburg, Germany
**    
**    CERIUM
**    Laboratoire SIM
**    Faculte de Medecine
**    2 Avenue du Pr. Leon Bernard
**    35043 Rennes Cedex, France
**  
**  for CEN/TC251/WG4 as a contribution to the Radiological 
**  Society of North America (RSNA) 1993 Digital Imaging and 
**  Communications in Medicine (DICOM) Demonstration.
**  
**  THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND NEITHER OFFIS,
**  OLDENBURG UNIVERSITY NOR CERIUM MAKE ANY WARRANTY REGARDING 
**  THE SOFTWARE, ITS PERFORMANCE, ITS MERCHANTABILITY OR 
**  FITNESS FOR ANY PARTICULAR USE, FREEDOM FROM ANY COMPUTER 
**  DISEASES OR ITS CONFORMITY TO ANY SPECIFICATION.  THE 
**  ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF THE SOFTWARE   
**  IS WITH THE USER. 
**  
**  Copyright of the software and supporting documentation
**  is, unless otherwise stated, jointly owned by OFFIS,
**  Oldenburg University and CERIUM and free access is hereby
**  granted as a license to use this software, copy this
**  software and prepare derivative works based upon this
**  software. However, any distribution of this software
**  source code or supporting documentation or derivative
**  works (source code and supporting documentation) must
**  include the three paragraphs of this copyright notice. 
** 
*/

#ifndef __CTNDISP_CONSTS_H
#define __CTNDISP_CONSTS_H

#include "snq.h" /* for MAX_STRING_LENGTH */

#define		KILL_DISPLAY		"KILL_DISPLAY"
#define		DEFAULT			0
#define		SLOPE_INTERCEPT		1
#define		WINDOW_LEVEL		2
#define		S_I_W_L			3
#define         MIN_DISPLAY_WIDTH   	100
#define         MIN_DISPLAY_HEIGHT	100

/*
 * Max percetage of screen to use for image display
 */
#define		MAX_PERCT		.90
#define		TEXT_POSITION		5
#define		QUEUE_SIZE		100

/* definitions for shared memory*/
#define EMPTY 0 /* image queue */
#define NOTEMPTY 1

#define PUT 0 /* get or put image element in image queue */
#define GET 1

#define IREADY 0 /*image calced ready */
#define ICALC 1 /* calculation in progress */
#define IFREE 2 /* no image in calc */
#define INEXT 3 /* calc the next image */

#endif /* __CTNDISP_CONSTS_H */
